# FoundationClasses
TKAdvTools
Dynamic

# Dynamic_FuzzyClass Class Reference

This class is the root class to dynamically define
objects of a given type but with various
definitions. This root class contains a parameter
list which describes in the definition context all
the useful information and in the instance context
only the redefined values. This class is deferred
because no instance has to be created.
.

`#include <Dynamic_FuzzyClass.hxx>`

Inheritance diagram for Dynamic_FuzzyClass:

[legend]

## Public Member Functions

virtual Standard_EXPORT TCollection_AsciiString | Type () const =0
| This deferred method must returns the type of the object. If the instance is of the type FuzzyDefinition the method simply returns the field <thetype>. If the instance is of the type FuzzyInstance the method calls the Type method on the true definition. .
Standard_EXPORT Handle_Dynamic_ParameterNode | FirstParameter () const
| Returns the head of the list of parameters. For the FuzzyDefinition class this method returns the head of the exaustive list of parameters defining the object and for the FuzzyInstance it just returns the head of the overloaded values. .
Standard_EXPORT Standard_Boolean | Parameter (const Standard_CString aparameter) const
| Returns true if there is a parameter with <aparameter> as name, false otherwise. .
Standard_EXPORT void | Parameter (const Handle(Dynamic_Parameter)&aparameter)
| Adds another parameter <aparameter> to the sequence of parameters. .
virtual Standard_EXPORT void | Parameter (const Standard_CString aparameter, const Standard_Boolean avalue)
| Adds to the instance <me> the parameter <aparameter> with the boolean value <avalue>. .
virtual Standard_EXPORT void | Parameter (const Standard_CString aparameter, const Standard_Integer avalue)
| Adds to the instance <me> the parameter <aparameter> with the integer value <avalue>. .
virtual Standard_EXPORT void | Parameter (const Standard_CString aparameter, const Standard_Real avalue)
| Adds to the instance <me> the parameter <aparameter> with the real value <avalue>. .
virtual Standard_EXPORT void | Parameter (const Standard_CString aparameter, const Standard_CString astring)
| Adds to the instance <me> the parameter <aparameter> with the string <astring>. .
virtual Standard_EXPORT void | Parameter (const Standard_CString aparameter, const Handle(Standard_Transient)&anobject)
| Adds to the instance <me> the parameter <aparameter> with the object value <anobject>. .
virtual Standard_EXPORT Standard_Boolean | Value (const Standard_CString aparameter, Standard_Boolean &avalue) const
| Returns True, if there is a parameter <aparameter> previously stored in the instance <me> and there is the corresponding boolean value in the output argument <avalue>, False otherwise. .
virtual Standard_EXPORT Standard_Boolean | Value (const Standard_CString aparameter, Standard_Integer &avalue) const
| Returns True, if there is a parameter <aparameter> previously stored in the instance <me> and there is the corresponding integer value in the output argument <avalue>, False otherwise. .
virtual Standard_EXPORT Standard_Boolean | Value (const Standard_CString aparameter, Standard_Real &avalue) const
| Returns True, if there is a parameter <aparameter> previously stored in the instance <me> and there is the corresponding real value in the output argument <avalue>, False otherwise. .
virtual Standard_EXPORT Standard_Boolean | Value (const Standard_CString aparameter, TCollection_AsciiString &avalue) const
| Returns True, if there is a parameter <aparameter> previously stored in the instance <me> and there is the corresponding string in the output argument <avalue>, False otherwise. .
virtual Standard_EXPORT Standard_Boolean | Value (const Standard_CString aparameter, Handle(Standard_Transient)&avalue) const
| Returns True, if there is a parameter <aparameter> previously stored in the instance <me> and there is the corresponding object value in the output argument <avalue>, False otherwise. .
virtual Standard_EXPORT void | Dump (Standard_OStream &astream) const
| Useful for debugging. .
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Protected Member Functions

Standard_EXPORT | Dynamic_FuzzyClass ()
| Creates a FuzzyClass. .

## Private Attributes

Handle_Dynamic_ParameterNode | thefirstparameternode

## Constructor & Destructor Documentation

Standard_EXPORT Dynamic_FuzzyClass::Dynamic_FuzzyClass | ( |  | ) | `[protected]`

## Member Function Documentation

virtual Standard_EXPORT void Dynamic_FuzzyClass::Dump | ( | Standard_OStream & | astream | ) | const`[virtual]`

| Reimplemented in Dynamic_FuzzyDefinition, Materials_FuzzyInstance, and Materials_Material.

Standard_EXPORT Handle_Dynamic_ParameterNode Dynamic_FuzzyClass::FirstParameter | ( |  | ) | const

Standard_EXPORT const Dynamic_FuzzyClass::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from MMgt_TShared. Reimplemented in Dynamic_FuzzyDefinition, Materials_FuzzyInstance, and Materials_Material.

virtual Standard_EXPORT void Dynamic_FuzzyClass::Parameter | ( | const Standard_CString | aparameter,
|  | const Handle(Standard_Transient)& | anobject
| ) | `[virtual]`

| Reimplemented in Materials_FuzzyInstance.

virtual Standard_EXPORT void Dynamic_FuzzyClass::Parameter | ( | const Standard_CString | aparameter,
|  | const Standard_CString | astring
| ) | `[virtual]`

| Reimplemented in Materials_FuzzyInstance.

virtual Standard_EXPORT void Dynamic_FuzzyClass::Parameter | ( | const Standard_CString | aparameter,
|  | const Standard_Real | avalue
| ) | `[virtual]`

| Reimplemented in Materials_FuzzyInstance.

virtual Standard_EXPORT void Dynamic_FuzzyClass::Parameter | ( | const Standard_CString | aparameter,
|  | const Standard_Integer | avalue
| ) | `[virtual]`

| Reimplemented in Materials_FuzzyInstance.

virtual Standard_EXPORT void Dynamic_FuzzyClass::Parameter | ( | const Standard_CString | aparameter,
|  | const Standard_Boolean | avalue
| ) | `[virtual]`

| Reimplemented in Materials_FuzzyInstance.

Standard_EXPORT void Dynamic_FuzzyClass::Parameter | ( | const Handle(Dynamic_Parameter)& | aparameter | ) |

Standard_EXPORT Standard_Boolean Dynamic_FuzzyClass::Parameter | ( | const Standard_CString | aparameter | ) | const

virtual Standard_EXPORT TCollection_AsciiString Dynamic_FuzzyClass::Type | ( |  | ) | const`[pure virtual]`

| Implemented in Dynamic_FuzzyDefinition, and Materials_FuzzyInstance.

virtual Standard_EXPORT Standard_Boolean Dynamic_FuzzyClass::Value | ( | const Standard_CString | aparameter,
|  | Handle(Standard_Transient)& | avalue
| ) | const`[virtual]`

| Reimplemented in Materials_FuzzyInstance.

virtual Standard_EXPORT Standard_Boolean Dynamic_FuzzyClass::Value | ( | const Standard_CString | aparameter,
|  | TCollection_AsciiString & | avalue
| ) | const`[virtual]`

| Reimplemented in Materials_FuzzyInstance.

virtual Standard_EXPORT Standard_Boolean Dynamic_FuzzyClass::Value | ( | const Standard_CString | aparameter,
|  | Standard_Real & | avalue
| ) | const`[virtual]`

| Reimplemented in Materials_FuzzyInstance.

virtual Standard_EXPORT Standard_Boolean Dynamic_FuzzyClass::Value | ( | const Standard_CString | aparameter,
|  | Standard_Integer & | avalue
| ) | const`[virtual]`

| Reimplemented in Materials_FuzzyInstance.

virtual Standard_EXPORT Standard_Boolean Dynamic_FuzzyClass::Value | ( | const Standard_CString | aparameter,
|  | Standard_Boolean & | avalue
| ) | const`[virtual]`

| Reimplemented in Materials_FuzzyInstance.

## Field Documentation

Handle_Dynamic_ParameterNode Dynamic_FuzzyClass::thefirstparameternode `[private]`

The documentation for this class was generated from the following file:

- Dynamic_FuzzyClass.hxx